summaryrefslogtreecommitdiff
path: root/tests/chmod/equals
diff options
context:
space:
mode:
Diffstat (limited to 'tests/chmod/equals')
-rwxr-xr-xtests/chmod/equals65
1 files changed, 65 insertions, 0 deletions
diff --git a/tests/chmod/equals b/tests/chmod/equals
new file mode 100755
index 0000000..dfaad17
--- /dev/null
+++ b/tests/chmod/equals
@@ -0,0 +1,65 @@
+#!/bin/sh
+# Make sure chmod mode arguments of the form A=B work properly.
+# Before fileutils-4.1.2, some of them didn't.
+# Also, before coreutils-5.3.1, =[ugo] sometimes didn't work.
+
+# Copyright (C) 2001, 2002, 2004, 2005, 2006 Free Software Foundation,
+# Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ chmod --version
+fi
+
+pwd=`pwd`
+tmp=equals.$$
+trap 'status=$?; cd "$pwd" && rm -rf $tmp && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+framework_failure=0
+mkdir $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+touch f || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+expected_u=-rwx------
+expected_g=----rwx---
+expected_o=-------rwx
+
+for src in u g o; do
+ for dest in u g o; do
+ test $dest = $src && continue
+ chmod a=,$src=rwx,$dest=$src,$src= f || fail=1
+ set _ `ls -l f`; shift; actual_perms=$1
+ expected_perms=`eval 'echo \$expected_'$dest`
+ test "$actual_perms" = "$expected_perms" || fail=1
+ done
+done
+
+umask 027
+chmod a=,u=rwx,=u f || fail=1
+set _ `ls -l f`; shift; actual_perms=$1
+test "$actual_perms" = "-rwxr-x---" || fail=1
+
+(exit $fail); exit $fail